diff --git a/libinterp/corefcn/jit-typeinfo.cc b/libinterp/corefcn/jit-typeinfo.cc
--- a/libinterp/corefcn/jit-typeinfo.cc
+++ b/libinterp/corefcn/jit-typeinfo.cc
@@ -531,9 +531,22 @@
 }
 
 // -------------------- jit_type --------------------
-jit_type::jit_type (const std::string& aname, jit_type *aparent,
-                    llvm::Type *allvm_type, bool askip_paren, int aid) :
-  mname (aname), mparent (aparent), llvm_type (allvm_type), mid (aid),
+jit_type::jit_type (const std::string& aname, jit_type *aparent
+#ifdef HAVE_LLVM                    
+                    , llvm::Type *allvm_type
+#endif
+#ifdef HAVE_LLVM                    
+                    , gccjit::type agcc_type
+#endif
+                    , bool askip_paren, int aid) :
+  mname (aname), mparent (aparent)
+#ifdef HAVE_LLVM                    
+  , llvm_type (allvm_type)
+#endif
+#ifdef HAVE_LLVM                    
+  , gccjit_type (agcc_type)
+#endif
+  , mid (aid),
   mdepth (aparent ? aparent->mdepth + 1 : 0), mskip_paren (askip_paren)
 {
   std::memset (msret, 0, sizeof (msret));
@@ -552,14 +565,17 @@
 }
 
 // -------------------- jit_function --------------------
-jit_function::jit_function () : module (0), llvm_function (0), mresult (0),
+jit_function::jit_function () : module (0), llvm_function (0),
+                                gccjit_function (),
+                                mresult (0),
                                 call_conv (jit_convention::length),
                                 mcan_error (false)
 {}
 
 jit_function::jit_function (llvm::Module *amodule,
+                            gccjit::context gccjit_ctxt,
                             jit_convention::type acall_conv,
-                            const llvm::Twine& aname, jit_type *aresult,
+                            std::string aname, jit_type *aresult,
                             const std::vector<jit_type *>& aargs)
   : module (amodule), mresult (aresult), args (aargs), call_conv (acall_conv),
     mcan_error (false)
@@ -613,17 +629,69 @@
 #else
     llvm_function->addFnAttr (llvm::Attribute::AlwaysInline);
 #endif
+
+    if (gccjit_ctxt.get_inner_context ())
+      {
+        std::vector<gccjit::param> gccjit_params;
+        for (int i = 0; i < args.size (); i++)
+          {
+            jit_type *ty = args[i];
+            assert (ty);
+
+            gccjit::type argty = ty->to_gccjit ();
+            if (ty->pointer_arg (call_conv))
+              argty = argty.get_pointer ();
+
+            std::stringstream paramname;
+            paramname << "arg" << i;
+
+            gccjit::param param = gccjit_ctxt.new_param (argty,
+                                                         paramname.str ());
+            gccjit_params.push_back (param);
+          }
+        gccjit::type gccjit_return_type;
+        if (aresult)
+          gccjit_return_type = aresult->to_gccjit ();
+        else
+          gccjit_return_type = gccjit_ctxt.get_type (GCC_JIT_TYPE_VOID);
+
+        enum gcc_jit_function_kind kind;
+        if (acall_conv == jit_convention::external)
+          kind = GCC_JIT_FUNCTION_IMPORTED;
+        else
+          {
+            if (0)
+              /* Doing this is correct, but makes the dump a little harder
+                 to read.
+                 Also, not fully implemented yet in libgccjit.  */
+              kind = GCC_JIT_FUNCTION_ALWAYS_INLINE;
+            else
+              kind = GCC_JIT_FUNCTION_EXPORTED;
+          }
+        gccjit_function =
+          gccjit_ctxt.new_function (kind,
+                                    gccjit_return_type,
+                                    aname,
+                                    gccjit_params,
+                                    0);
+      }
 }
 
 jit_function::jit_function (const jit_function& fn, jit_type *aresult,
                             const std::vector<jit_type *>& aargs)
-  : module (fn.module), llvm_function (fn.llvm_function), mresult (aresult),
+  : module (fn.module),
+    llvm_function (fn.llvm_function), 
+    gccjit_function (fn.gccjit_function),
+    mresult (aresult),
     args (aargs), call_conv (fn.call_conv), mcan_error (fn.mcan_error)
 {
 }
 
 jit_function::jit_function (const jit_function& fn)
-  : module (fn.module), llvm_function (fn.llvm_function), mresult (fn.mresult),
+  : module (fn.module),
+    llvm_function (fn.llvm_function), 
+    gccjit_function (fn.gccjit_function),
+    mresult (fn.mresult),
     args (fn.args), call_conv (fn.call_conv), mcan_error (fn.mcan_error)
 {}
 
@@ -781,8 +849,76 @@
 
   if (verify)
     llvm::verifyFunction (*llvm_function);
+
+  if (0)
+    {
+      std::cout << "-------------------- llvm ir (at do_return) --------------------";
+      std::cout << *llvm_function << std::endl;
+    }
 }
 
+#ifdef HAVE_GCCJIT
+#if 1
+gccjit::rvalue
+jit_function::call (gccjit::context ctxt,
+                    gccjit::block block,
+                    const std::vector<jit_value *>& in_args) const
+{
+  assert (in_args.size () == args.size ());
+  std::vector<gccjit::rvalue> gccjit_args (args.size ());
+  for (size_t i = 0; i < in_args.size (); ++i)
+    gccjit_args[i] = in_args[i]->as_rvalue ();
+  return call (ctxt, block, gccjit_args);
+}
+
+gccjit::rvalue
+jit_function::call (gccjit::context ctxt,
+                    gccjit::block block,
+                    std::vector<gccjit::rvalue>& in_args) const
+{
+  assert (in_args.size () == args.size ());
+
+#if 1
+  std::vector<gccjit::rvalue> packed_args (in_args.size ());
+
+  for (size_t i = 0; i < in_args.size (); ++i)
+    {
+      gccjit::rvalue arg = in_args[i];
+#if 0      
+      jit_type::convert_fn convert = args[i]->pack (call_conv);
+      if (convert)
+        arg = convert (builder, arg);
+#endif
+
+      if (args[i]->pointer_arg (call_conv))
+        {
+          // The LLVM implementation takes a copy using alloca, passing
+          // a ptr to the copy to the fn.  Emulate this behavior.
+          gccjit::lvalue tmp =
+            block.get_function ().new_local (arg.get_type (), "tmp");
+          block.add_assignment (tmp, arg);
+          arg = tmp.get_address ();
+        }
+
+      packed_args[i] = arg;
+    }
+
+  return ctxt.new_call (gccjit_function,
+                        packed_args);
+#else
+  return ctxt.new_call (gccjit_function,
+                        in_args);
+#endif
+}
+#endif
+
+gccjit::lvalue
+jit_function::argument (size_t idx) const
+{
+  return gccjit_function.get_param (idx);
+}
+#endif
+
 void
 jit_function::do_add_mapping (llvm::ExecutionEngine *engine, void *fn)
 {
@@ -955,6 +1091,7 @@
   return 0;
 }
 
+#ifdef HAVE_LLVM
 llvm::Value *
 jit_index_operation::create_arg_array (llvm::IRBuilderD& builder,
                                        const jit_function &fn, size_t start_idx,
@@ -974,6 +1111,28 @@
   builder.CreateStore (array, array_mem);
   return builder.CreateBitCast (array_mem, scalar_t->getPointerTo ());
 }
+#endif // #ifdef HAVE_LLVM
+
+#ifdef HAVE_GCCJIT
+gccjit::rvalue
+jit_index_operation::create_arg_array (const jit_function &fn,
+                                       gccjit::block block,
+                                       size_t start_idx,
+                                       size_t end_idx) const
+{
+  size_t n = end_idx - start_idx;
+  gccjit::type scalar_t = jit_typeinfo::get_scalar_gccjit ();
+  gccjit::type array_t = block.get_context ().new_array_type (scalar_t, n);
+  gccjit::lvalue array =
+    block.get_function ().new_local (array_t, "tmp_array");
+  for (size_t i = start_idx; i < end_idx; ++i)
+    {
+      gccjit::rvalue idx = fn.argument (i);
+      block.add_assignment (array[i - start_idx], idx);
+    }
+  return array.get_address ().cast_to (scalar_t.get_pointer ());
+}
+#endif // #ifdef HAVE_GCCJIT
 
 // -------------------- jit_paren_subsref --------------------
 jit_function *
@@ -983,7 +1142,9 @@
   ss << "jit_paren_subsref_matrix_scalar" << (types.size () - 1);
 
   jit_type *scalar = jit_typeinfo::get_scalar ();
-  jit_function *fn = new jit_function (module, jit_convention::internal,
+  jit_function *fn = new jit_function (module,
+                                       gccjit_ctxt,
+                                       jit_convention::internal,
                                        ss.str (), scalar, types);
   fn->mark_can_error ();
   llvm::BasicBlock *body = fn->new_block ();
@@ -996,6 +1157,24 @@
   llvm::Value *mat = fn->argument (builder, 0);
   llvm::Value *ret = paren_scalar.call (builder, mat, array, nelem);
   fn->do_return (builder, ret);
+
+  // gcc implementation
+  {
+    gccjit::function gf = fn->gccjit_function;
+    gccjit::block body = gf.new_block ();
+    gccjit::rvalue array = create_arg_array (*fn, body, 1, types.size ());
+    jit_type *index = jit_typeinfo::get_index ();
+    gccjit::rvalue nelem = gccjit_ctxt.new_rvalue (index->to_gccjit (),
+                                                   (int)types.size () - 1);
+    gccjit::rvalue mat = gf.get_param (0);
+    std::vector<gccjit::rvalue> args (3);
+    args[0] = mat;
+    args[1] = array;
+    args[2] = nelem;
+    gccjit::rvalue ret = paren_scalar.call (gccjit_ctxt, body, args);
+    body.end_with_return (ret);
+  }
+
   return fn;
 }
 
@@ -1008,7 +1187,9 @@
   types[2] = jit_typeinfo::get_index ();
 
   jit_type *scalar = jit_typeinfo::get_scalar ();
-  paren_scalar = jit_function (module, jit_convention::external,
+  paren_scalar = jit_function (module,
+                               gccjit_ctxt,
+                               jit_convention::external,
                                "octave_jit_paren_scalar", scalar, types);
   paren_scalar.add_mapping (engine, &octave_jit_paren_scalar);
   paren_scalar.mark_can_error ();
@@ -1022,7 +1203,9 @@
   ss << "jit_paren_subsasgn_matrix_scalar" << (types.size () - 2);
 
   jit_type *matrix = jit_typeinfo::get_matrix ();
-  jit_function *fn = new jit_function (module, jit_convention::internal,
+  jit_function *fn = new jit_function (module,
+                                       gccjit_ctxt,
+                                       jit_convention::internal,
                                        ss.str (), matrix, types);
   fn->mark_can_error ();
   llvm::BasicBlock *body = fn->new_block ();
@@ -1037,6 +1220,27 @@
   llvm::Value *value = fn->argument (builder, types.size () - 1);
   llvm::Value *ret = paren_scalar.call (builder, mat, array, nelem, value);
   fn->do_return (builder, ret);
+
+  // gcc implementation
+  {
+    // FIXME: TODO
+    gccjit::function gf = fn->gccjit_function;
+    gccjit::block body = gf.new_block ();
+    gccjit::rvalue array = create_arg_array (*fn, body, 1, types.size () - 1);
+    jit_type *index = jit_typeinfo::get_index ();
+    gccjit::rvalue nelem = gccjit_ctxt.new_rvalue (index->to_gccjit (),
+                                                   (int)types.size () - 2);
+    gccjit::rvalue mat = gf.get_param (0);
+    gccjit::rvalue value = gf.get_param (types.size () - 1);
+    std::vector<gccjit::rvalue> args(4);
+    args[0] = mat;
+    args[1] = array;
+    args[2] = nelem;
+    args[3] = value;
+    gccjit::rvalue ret = paren_scalar.call (gccjit_ctxt, body, args);
+    body.end_with_return (ret);
+  }
+
   return fn;
 }
 
@@ -1053,7 +1257,9 @@
   types[2] = jit_typeinfo::get_index ();
   types[3] = jit_typeinfo::get_scalar ();
 
-  paren_scalar = jit_function (module, jit_convention::external,
+  paren_scalar = jit_function (module,
+                               gccjit_ctxt,
+                               jit_convention::external,
                                "octave_jit_paren_scalar", matrix, types);
   paren_scalar.add_mapping (engine, &octave_jit_paren_scalar_subsasgn);
   paren_scalar.mark_can_error ();
@@ -1075,7 +1281,12 @@
 {
   instance = this;
 
+#ifdef HAVE_GCCJIT
+  gccjit_ctxt = gccjit::context::acquire ();
+#endif
+
   // FIXME: We should be registering types like in octave_value_typeinfo
+#ifdef HAVE_LLVM
   llvm::Type *any_t = llvm::StructType::create (context, "octave_base_value");
   any_t = any_t->getPointerTo ();
 
@@ -1085,14 +1296,54 @@
   string_t = string_t->getPointerTo ();
   llvm::Type *index_t = llvm::Type::getIntNTy (context,
                                                sizeof(octave_idx_type) * 8);
-
+#endif
+
+#ifdef HAVE_GCCJIT
+  gccjit::type any_t_gcc =
+    gccjit_ctxt.new_opaque_struct_type ("octave_base_value");
+  any_t_gcc = any_t_gcc.get_pointer ();
+  gccjit::type scalar_t_gcc = gccjit_ctxt.get_type (GCC_JIT_TYPE_DOUBLE);
+  gccjit::type bool_t_gcc = gccjit_ctxt.get_type (GCC_JIT_TYPE_BOOL);
+  gccjit::type string_t_gcc =
+    gccjit_ctxt.get_type (GCC_JIT_TYPE_CHAR).get_pointer ();
+  gccjit::type index_t_gcc = gccjit_ctxt.get_int_type <octave_idx_type> ();
+  gccjit::type int_t_gcc = gccjit_ctxt.get_type (GCC_JIT_TYPE_INT);
+#endif
+
+#ifdef HAVE_LLVM
   llvm::StructType *range_t = llvm::StructType::create (context, "range");
   std::vector<llvm::Type *> range_contents (4, scalar_t);
   range_contents[3] = index_t;
   range_t->setBody (range_contents);
-
+#endif
+#ifdef HAVE_GCCJIT
+  field_rng_base = gccjit_ctxt.new_field (scalar_t_gcc, "rng_base");
+  field_rng_limit = gccjit_ctxt.new_field (scalar_t_gcc, "rng_limit");
+  field_rng_inc = gccjit_ctxt.new_field (scalar_t_gcc, "rng_inc");
+  field_rng_nelem = gccjit_ctxt.new_field (index_t_gcc, "rng_nelem");
+  /* FIXME: what about the "mutable Matrix cache;" */
+
+  std::vector<gccjit::field> range_fields (4);
+  range_fields [0] = field_rng_base;
+  range_fields [1] = field_rng_limit;
+  range_fields [2] = field_rng_inc;
+  range_fields [3] = field_rng_nelem;
+
+  gccjit::type range_t_gcc =
+    gccjit_ctxt.new_struct_type (
+      "range",
+      range_fields,
+      gccjit_ctxt.new_location ("liboctave/array/Range.h", 33, 0));
+#endif
+
+#ifdef HAVE_LLVM
   llvm::Type *refcount_t = llvm::Type::getIntNTy (context, sizeof(int) * 8);
-
+#endif
+#ifdef HAVE_GCCJIT
+  gccjit::type refcount_t_gcc = gccjit_ctxt.get_type (GCC_JIT_TYPE_INT);
+#endif
+
+#ifdef HAVE_LLVM
   llvm::StructType *matrix_t = llvm::StructType::create (context, "matrix");
   llvm::Type *matrix_contents[5];
   matrix_contents[0] = refcount_t->getPointerTo ();
@@ -1101,8 +1352,58 @@
   matrix_contents[3] = index_t->getPointerTo ();
   matrix_contents[4] = string_t;
   matrix_t->setBody (llvm::makeArrayRef (matrix_contents, 5));
-
+#endif
+#ifdef HAVE_GCCJIT
+  /*
+    jit-typeinfo.h has, somewhat ominously:
+       // jit_array is compatable with the llvm array/matrix structures
+     typedef jit_array<NDArray, double> jit_matrix;
+  */
+  gccjit::type matrix_t_gcc;
+  {
+    /* typedef jit_array<NDArray, double> jit_matrix; */
+    /* template <typename T, typename U> struct jit_array {...}; */
+    gccjit::type T = string_t_gcc; /* NDArray */
+    gccjit::type U = scalar_t_gcc; /* double */
+
+    /* int *ref_count; */
+    field_ref_count =
+      gccjit_ctxt.new_field (refcount_t_gcc.get_pointer (), "ref_count");
+
+    /* U *slice_data; */
+    field_slice_data =
+      gccjit_ctxt.new_field (U.get_pointer (), "slice_data");
+
+    /* octave_idx_type slice_len; */
+    field_slice_len = gccjit_ctxt.new_field (index_t_gcc, "slice_len");
+
+    /* octave_idx_type *dimensions; */
+    field_dimensions =
+      gccjit_ctxt.new_field (index_t_gcc.get_pointer (), "dimensions");
+
+    /* T *array; */
+    field_array = gccjit_ctxt.new_field (T.get_pointer (), "array");
+
+    std::vector<gccjit::field> matrix_fields (5);
+    matrix_fields[0] = field_ref_count;
+    matrix_fields[1] = field_slice_data;
+    matrix_fields[2] = field_slice_len;
+    matrix_fields[3] = field_dimensions;
+    matrix_fields[4] = field_array;
+
+    matrix_t_gcc = gccjit_ctxt.new_struct_type (
+      "jit_matrix",
+      matrix_fields,
+      gccjit_ctxt.new_location ("jit-typeinfo.h", 106, 0));
+  }
+#endif
+
+#ifdef HAVE_LLVM
   llvm::Type *complex_t = llvm::ArrayType::get (scalar_t, 2);
+#endif
+#ifdef HAVE_GCCJIT
+  gccjit::type complex_t_gcc = gccjit_ctxt.new_array_type (scalar_t_gcc, 2);
+#endif
 
   // complex_ret is what is passed to C functions in order to get calling
   // convention right
@@ -1116,16 +1417,18 @@
   }
 
   // create types
-  any = new_type ("any", 0, any_t);
-  matrix = new_type ("matrix", any, matrix_t);
-  complex = new_type ("complex", any, complex_t);
-  scalar = new_type ("scalar", complex, scalar_t);
-  scalar_ptr = new_type ("scalar_ptr", 0, scalar_t->getPointerTo ());
-  any_ptr = new_type ("any_ptr", 0, any_t->getPointerTo ());
-  range = new_type ("range", any, range_t);
-  string = new_type ("string", any, string_t);
-  boolean = new_type ("bool", any, bool_t);
-  index = new_type ("index", any, index_t);
+  any = new_type ("any", 0, any_t, any_t_gcc);
+  matrix = new_type ("matrix", any, matrix_t, matrix_t_gcc);
+  complex = new_type ("complex", any, complex_t, complex_t_gcc);
+  scalar = new_type ("scalar", complex, scalar_t, scalar_t_gcc);
+  scalar_ptr = new_type ("scalar_ptr", 0, scalar_t->getPointerTo (),
+    scalar_t_gcc.get_pointer ());
+  any_ptr = new_type ("any_ptr", 0, any_t->getPointerTo (),
+    any_t_gcc.get_pointer());
+  range = new_type ("range", any, range_t, range_t_gcc);
+  string = new_type ("string", any, string_t, string_t_gcc);
+  boolean = new_type ("bool", any, bool_t, bool_t_gcc);
+  index = new_type ("index", any, index_t, index_t_gcc);
 
   create_int (8);
   create_int (16);
@@ -1151,10 +1454,11 @@
   if (sizeof (void *) == 4)
     complex->mark_sret (jit_convention::external);
 
-  paren_subsref_fn.initialize (module, engine);
-  paren_subsasgn_fn.initialize (module, engine);
+  paren_subsref_fn.initialize (module, engine, gccjit_ctxt);
+  paren_subsasgn_fn.initialize (module, engine, gccjit_ctxt);
 
   // bind global variables
+#ifdef HAVE_LLVM
   lerror_state = new llvm::GlobalVariable (*module, bool_t, false,
                                            llvm::GlobalValue::ExternalLinkage,
                                            0, "error_state");
@@ -1169,6 +1473,20 @@
                                 "octave_interrupt_state");
   engine->addGlobalMapping (loctave_interrupt_state,
                             reinterpret_cast<void *> (&octave_interrupt_state));
+#endif
+
+#ifdef HAVE_GCCJIT
+  // Access "error_state" (actually declared as an "int"), by
+  // taking its address and dereferencing:
+  error_state_gccjit =
+    *gccjit_ctxt.new_rvalue (int_t_gcc.get_pointer (),
+                             &error_state);
+  sig_atomic_type_gccjit = gccjit_ctxt.get_int_type <sig_atomic_t> ();
+  octave_interrupt_state_gccjit =
+    *gccjit_ctxt.new_rvalue (
+      sig_atomic_type_gccjit.get_volatile ().get_pointer (),
+        &octave_interrupt_state);
+#endif
 
   // generic call function
   {
@@ -1202,8 +1520,10 @@
 
   for (int op = 0; op < octave_value::num_binary_ops; ++op)
     {
-      llvm::Twine fn_name ("octave_jit_binary_any_any_");
-      fn_name = fn_name + llvm::Twine (op);
+      std::string fn_name ("octave_jit_binary_any_any_");
+      char buf[64];
+      snprintf (buf, sizeof(buf), "%i", op);
+      fn_name = fn_name + std::string (buf);
 
       fn = create_internal (fn_name, any, any, any);
       fn.mark_can_error ();
@@ -1216,6 +1536,18 @@
                                           fn.argument (builder, 0),
                                           fn.argument (builder, 1));
       fn.do_return (builder, ret);
+
+      // gccjit implementation of octave_jit_binary_any_any_*:
+      gccjit::function gf = fn.gccjit_function;
+      gccjit::block gccjit_block = gf.new_block ();
+      gccjit_block.end_with_return (
+        gccjit_block.add_call (
+          any_binary.gccjit_function,
+          gccjit_ctxt.new_rvalue (binary_op_type->to_gccjit (),
+                                  op),
+          gf.get_param (0),
+          gf.get_param (1)));
+                                     
       binary_ops[op].add_overload (fn);
     }
 
@@ -1247,20 +1579,38 @@
   destroy_fn.add_overload (create_identity(index));
   destroy_fn.add_overload (create_identity(complex));
 
-  // -------------------- scalar related operations --------------------
-
   // now for binary scalar operations
-  add_binary_op (scalar, octave_value::op_add, llvm::Instruction::FAdd);
-  add_binary_op (scalar, octave_value::op_sub, llvm::Instruction::FSub);
-  add_binary_op (scalar, octave_value::op_mul, llvm::Instruction::FMul);
-  add_binary_op (scalar, octave_value::op_el_mul, llvm::Instruction::FMul);
-
-  add_binary_fcmp (scalar, octave_value::op_lt, llvm::CmpInst::FCMP_ULT);
-  add_binary_fcmp (scalar, octave_value::op_le, llvm::CmpInst::FCMP_ULE);
-  add_binary_fcmp (scalar, octave_value::op_eq, llvm::CmpInst::FCMP_UEQ);
-  add_binary_fcmp (scalar, octave_value::op_ge, llvm::CmpInst::FCMP_UGE);
-  add_binary_fcmp (scalar, octave_value::op_gt, llvm::CmpInst::FCMP_UGT);
-  add_binary_fcmp (scalar, octave_value::op_ne, llvm::CmpInst::FCMP_UNE);
+  add_binary_op (scalar, octave_value::op_add,
+                 llvm::Instruction::FAdd,
+                 GCC_JIT_BINARY_OP_PLUS);
+  add_binary_op (scalar, octave_value::op_sub,
+                 llvm::Instruction::FSub,
+                 GCC_JIT_BINARY_OP_MINUS);
+  add_binary_op (scalar, octave_value::op_mul,
+                 llvm::Instruction::FMul,
+                 GCC_JIT_BINARY_OP_MULT);
+  add_binary_op (scalar, octave_value::op_el_mul,
+                 llvm::Instruction::FMul,
+                 GCC_JIT_BINARY_OP_MULT);
+
+  add_binary_fcmp (scalar, octave_value::op_lt,
+                   llvm::CmpInst::FCMP_ULT,
+                   GCC_JIT_COMPARISON_LT);
+  add_binary_fcmp (scalar, octave_value::op_le,
+                   llvm::CmpInst::FCMP_ULE,
+                   GCC_JIT_COMPARISON_LE);
+  add_binary_fcmp (scalar, octave_value::op_eq,
+                   llvm::CmpInst::FCMP_UEQ,
+                   GCC_JIT_COMPARISON_EQ);
+  add_binary_fcmp (scalar, octave_value::op_ge,
+                   llvm::CmpInst::FCMP_UGE,
+                   GCC_JIT_COMPARISON_GE);
+  add_binary_fcmp (scalar, octave_value::op_gt,
+                   llvm::CmpInst::FCMP_UGT,
+                   GCC_JIT_COMPARISON_GT);
+  add_binary_fcmp (scalar, octave_value::op_ne,
+                   llvm::CmpInst::FCMP_UNE,
+                   GCC_JIT_COMPARISON_NE);
 
   jit_function gripe_div0 = create_external (JIT_FN (gripe_divide_by_zero), 0);
   gripe_div0.mark_can_error ();
@@ -1288,6 +1638,22 @@
                                            fn.argument (builder, 1));
     fn.do_return (builder, ret);
   }
+  // gccjit implementation of octave_jit_div_scalar_scalar:
+  {
+    gccjit::function gf = fn.gccjit_function;
+    gccjit::block initial_block = gf.new_block ("initial");
+    gccjit::block warn_block = gf.new_block ("warn");
+    gccjit::block normal_block = gf.new_block ("normal");
+    initial_block.end_with_conditional (
+      gf.get_param (1) != scalar_t_gcc.zero (),
+      normal_block, // on_true
+      warn_block); // on_false
+
+    warn_block.add_call (gripe_div0.gccjit_function);
+    warn_block.end_with_jump (normal_block);
+
+    normal_block.end_with_return (gf.get_param (0) / gf.get_param (1));
+  }
   binary_ops[octave_value::op_div].add_overload (fn);
   binary_ops[octave_value::op_el_div].add_overload (fn);
 
@@ -1306,7 +1672,7 @@
 
   // now for unary scalar operations
   // FIXME: Impelment not
-  fn = create_internal ("octave_jit_++", scalar, scalar);
+  fn = create_internal ("octave_jit_plusplus", scalar, scalar);
   body = fn.new_block ();
   builder.SetInsertPoint (body);
   {
@@ -1315,9 +1681,15 @@
     val = builder.CreateFAdd (val, one);
     fn.do_return (builder, val);
   }
+  // gccjit implementation of octave_jit_plusplus:
+  {
+    gccjit::function gf = fn.gccjit_function;
+    gccjit::block b = gf.new_block ();
+    b.end_with_return (gf.get_param (0) + scalar_t_gcc.one ());
+  }
   unary_ops[octave_value::op_incr].add_overload (fn);
 
-  fn = create_internal ("octave_jit_--", scalar, scalar);
+  fn = create_internal ("octave_jit_minusminus", scalar, scalar);
   body = fn.new_block ();
   builder.SetInsertPoint (body);
   {
@@ -1325,6 +1697,11 @@
     llvm::Value *val = fn.argument (builder, 0);
     val = builder.CreateFSub (val, one);
     fn.do_return (builder, val);
+
+    // gccjit implementation of octave_jit_minusminus:
+    gccjit::function gf = fn.gccjit_function;
+    gccjit::block b = gf.new_block ();
+    b.end_with_return (gf.get_param (0) - scalar_t_gcc.one ());
   }
   unary_ops[octave_value::op_decr].add_overload (fn);
 
@@ -1337,7 +1714,12 @@
     val = builder.CreateFMul (val, mone);
     fn.do_return (builder, val);
   }
-  unary_ops[octave_value::op_uminus].add_overload (fn);
+  // gccjit implementation of octave_jit_uminus:
+  {
+    gccjit::function gf = fn.gccjit_function;
+    gccjit::block b = gf.new_block ();
+    b.end_with_return (-gf.get_param (0));
+  }
 
   fn = create_identity (scalar);
   unary_ops[octave_value::op_uplus].add_overload (fn);
@@ -1345,7 +1727,7 @@
   unary_ops[octave_value::op_hermitian].add_overload (fn);
 
   // now for binary complex operations
-  fn = create_internal ("octave_jit_+_complex_complex", complex, complex,
+  fn = create_internal ("octave_jit_plus_complex_complex", complex, complex,
                         complex);
   body = fn.new_block ();
   builder.SetInsertPoint (body);
@@ -1358,9 +1740,19 @@
                                             complex_imag (rhs));
     fn.do_return (builder, complex_new (real, imag));
   }
+  // gccjit implementation of octave_jit_plus_complex_complex:
+  {
+    gccjit::function gf = fn.gccjit_function;
+    gccjit::block b = gf.new_block ();
+    gccjit::rvalue lhs = gf.get_param (0);
+    gccjit::rvalue rhs = gf.get_param (1);
+    gccjit::rvalue real = complex_real (lhs) + complex_real (rhs);
+    gccjit::rvalue imag = complex_imag (lhs) + complex_imag (rhs);
+    b.end_with_return (complex_new (b, real, imag));
+  }
   binary_ops[octave_value::op_add].add_overload (fn);
 
-  fn = create_internal ("octave_jit_-_complex_complex", complex, complex,
+  fn = create_internal ("octave_jit_minus_complex_complex", complex, complex,
                         complex);
   body = fn.new_block ();
   builder.SetInsertPoint (body);
@@ -1373,6 +1765,16 @@
                                             complex_imag (rhs));
     fn.do_return (builder, complex_new (real, imag));
   }
+  // gccjit implementation of octave_jit_minus_complex_complex:
+  {
+    gccjit::function gf = fn.gccjit_function;
+    gccjit::block b = gf.new_block ();
+    gccjit::rvalue lhs = gf.get_param (0);
+    gccjit::rvalue rhs = gf.get_param (1);
+    gccjit::rvalue real = complex_real (lhs) - complex_real (rhs);
+    gccjit::rvalue imag = complex_imag (lhs) - complex_imag (rhs);
+    b.end_with_return (complex_new (b, real, imag));
+  }
   binary_ops[octave_value::op_sub].add_overload (fn);
 
   fn = create_external (JIT_FN (octave_jit_complex_mul),
@@ -1391,7 +1793,7 @@
   binary_ops[octave_value::op_pow].add_overload (fn);
   binary_ops[octave_value::op_el_pow].add_overload (fn);
 
-  fn = create_internal ("octave_jit_*_scalar_complex", complex, scalar,
+  fn = create_internal ("octave_jit_mult_scalar_complex", complex, scalar,
                         complex);
   jit_function mul_scalar_complex = fn;
   body = fn.new_block ();
@@ -1418,6 +1820,29 @@
                         builder.CreateFMul (lhs, complex_imag (rhs)));
     fn.do_return (builder, temp);
   }
+  // gccjit implementation of octave_jit_mult_scalar_complex:
+  {
+    gccjit::function gf = fn.gccjit_function;
+
+    gccjit::rvalue fzero = scalar_t_gcc.zero ();
+    gccjit::rvalue lhs = gf.get_param (0);
+    gccjit::rvalue rhs = gf.get_param (1);
+
+    gccjit::block initial = gf.new_block ("initial");
+    gccjit::block complex_mul = gf.new_block ("complex_mul");
+    gccjit::block scalar_mul = gf.new_block ("scalar_mul");
+
+    initial.end_with_conditional (complex_imag (rhs) == fzero,
+                                  scalar_mul,
+                                  complex_mul);
+
+    scalar_mul.end_with_return (complex_new (scalar_mul,
+                                             lhs * complex_real (rhs),
+                                             fzero));
+    complex_mul.end_with_return (complex_new (complex_mul,
+                                              lhs * complex_real (rhs),
+                                              lhs * complex_imag (rhs)));
+  }
   binary_ops[octave_value::op_mul].add_overload (fn);
   binary_ops[octave_value::op_el_mul].add_overload (fn);
 
@@ -1426,7 +1851,7 @@
   binary_ops[octave_value::op_mul].add_overload (fn);
   binary_ops[octave_value::op_el_mul].add_overload (fn);
 
-  fn = create_internal ("octave_jit_+_scalar_complex", complex, scalar,
+  fn = create_internal ("octave_jit_plus_scalar_complex", complex, scalar,
                         complex);
   body = fn.new_block ();
   builder.SetInsertPoint (body);
@@ -1436,12 +1861,21 @@
     llvm::Value *real = builder.CreateFAdd (lhs, complex_real (rhs));
     fn.do_return (builder, complex_real (rhs, real));
   }
+  // gccjit implementation of octave_jit_plus_scalar_complex:
+  {
+    gccjit::function gf = fn.gccjit_function;
+    gccjit::block b = gf.new_block ();
+    gccjit::rvalue lhs = gf.get_param (0);
+    gccjit::lvalue rhs = gf.get_param (1);
+    gccjit::rvalue real = lhs + complex_real (rhs);
+    b.end_with_return (complex_real (b, rhs, real));
+  }
   binary_ops[octave_value::op_add].add_overload (fn);
 
   fn = mirror_binary (fn);
   binary_ops[octave_value::op_add].add_overload (fn);
 
-  fn = create_internal ("octave_jit_-_complex_scalar", complex, complex,
+  fn = create_internal ("octave_jit_minus_complex_scalar", complex, complex,
                         scalar);
   body = fn.new_block ();
   builder.SetInsertPoint (body);
@@ -1451,9 +1885,18 @@
     llvm::Value *real = builder.CreateFSub (complex_real (lhs), rhs);
     fn.do_return (builder, complex_real (lhs, real));
   }
+  // gccjit implementation of octave_jit_minus_complex_scalar:
+  {
+    gccjit::function gf = fn.gccjit_function;
+    gccjit::block b = gf.new_block ();
+    gccjit::lvalue lhs = gf.get_param (0);
+    gccjit::rvalue rhs = gf.get_param (1);
+    gccjit::rvalue real = complex_real (lhs) - rhs;
+    b.end_with_return (complex_real (b, lhs, real));
+  }
   binary_ops[octave_value::op_sub].add_overload (fn);
 
-  fn = create_internal ("octave_jit_-_scalar_complex", complex, scalar,
+  fn = create_internal ("octave_jit_minus_scalar_complex", complex, scalar,
                         complex);
   body = fn.new_block ();
   builder.SetInsertPoint (body);
@@ -1463,6 +1906,15 @@
     llvm::Value *real = builder.CreateFSub (lhs, complex_real (rhs));
     fn.do_return (builder, complex_real (rhs, real));
   }
+  // gccjit implementation of octave_jit_minus_scalar_complex:
+  {
+    gccjit::function gf = fn.gccjit_function;
+    gccjit::block b = gf.new_block ();
+    gccjit::rvalue lhs = gf.get_param (0);
+    gccjit::lvalue rhs = gf.get_param (1);
+    gccjit::rvalue real = lhs - complex_real (rhs);
+    b.end_with_return (complex_real (b, rhs, real));
+  }
   binary_ops[octave_value::op_sub].add_overload (fn);
 
   fn = create_external (JIT_FN (octave_jit_pow_scalar_complex), complex, scalar,
